#!/bin/sh
#Copyright by TQ Binh, 2018

#this script is used to modify a value of MSR registry. It read current value, doing bitwise operation and then write back to an MSR registry
# example: the following command read MSR registry 0x1a0 (IA32_MISC_ENABLES, or 1A0H in intel manual), do bitwise OR with 0x40000000 and write back to MSR
#to disable turbo boost: ./MSR_mod.sh 0x1a0 OR 0x4000000000
#to enable turbo boost: ./MSR_mod.sh 0x1a0 AND 0xFFFBFFFFFFFFF  (or 0xBFFFFFFFFF)
 
V_MODIFICATION_VALUE="0x000"  #default modification value is 0, default operation is OR -> by default, read value does not change
V_ADDRESS="$1"  #first parameter is the MSR registry address
V_OPERATION="$2" # second parameter is bitwise operation (OR for setting to 1, AND for setting to 0, XOR for toggling bit)
V_MODIFICATION_VALUE="$3" # third parameter is the value to do bitwise operation with MSR value

# read the current value of MSR registry with specific address
FULL_RES=$(sudo ./voltageshift read $V_ADDRESS)

#delete the longest part from beginning of string to 0x delimiter, see https://stackoverflow.com/questions/19482123/extract-part-of-a-string-using-bash-cut-split
RES=${FULL_RES##*0x} 
# add 0x prefix
RES="0x$RES"

#bitwise operation: https://stackoverflow.com/questions/40667382/how-to-perform-bitwise-operations-on-hexadecimal-numbers-in-bash
if [ "$V_OPERATION" = "XOR" ] ; then
	NEW_VAL=$((RES ^ V_MODIFICATION_VALUE))   # bitwise XOR
elif [  "$V_OPERATION" = "AND" ] ; then
	NEW_VAL=$((RES & V_MODIFICATION_VALUE))  # bitwise AND
else
	NEW_VAL=$((RES | V_MODIFICATION_VALUE))  #default is OR
fi
# convert number to hexadecimal format with prefix 0x
NEW_VAL=$(printf '0x%x\n' $NEW_VAL)
# write to MSR registry
sudo ./voltageshift write $V_ADDRESS $NEW_VAL

#echo "address and value to be written: $V_ADDRESS $NEW_VAL"